diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index 6f9ac3165..dade5a67e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -6,119 +6,121 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard<T> {
     public BlockModelDoor(Block<T> block) {
         super(block);
     }
-    
-    public void setBrightness(Tessellator tessellator, WorldSource worldSource, int x, int y, int z, float sideBrightness) {
-    	float brightness = sideBrightness;
-    	if(LightmapHelper.isLightmapEnabled()) {
-    		tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-    	}else {
-    		brightness *= renderBlocks.getBlockBrightness(worldSource, x, y, z);
-    	}
-    	tessellator.setColorOpaque_F(brightness, brightness, brightness);
+
+    public void setBrightness(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, float sideBrightness) {
+        float brightness = sideBrightness;
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness *= renderBlocks.getBlockBrightness(worldSource, tilePos);
+        }
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
     }
-    
+
     @Override
-	public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-    	if(LightmapHelper.isLightmapEnabled()) {
-    		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
-    	}
-    	tessellator.setColorOpaque_F(1.0f, 1.0f, 1.0f);
-
-		AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
-
-		float sideBottom = 1.0f;
-		float sideTop = 1.0f;
-		float sideNorthSouth = 1.0f;
-		float sideEastWest = 1.0f;
-		if(ENABLE_DIRECTIONAL_LIGHTING) {
-			sideBottom = 0.5f;
-			sideTop = 1.0f;
-			sideNorthSouth = 0.8f;
-			sideEastWest = 0.6f;
-		}
-		
-		boolean aboveIsDoor = Block.hasLogicClass(worldSource.getBlock(x, y + 1, z), BlockLogicDoor.class);
-		boolean belowIsDoor = Block.hasLogicClass(worldSource.getBlock(x, y - 1, z), BlockLogicDoor.class);
-
-		int meta = worldSource.getBlockMetadata(x, y, z);
-		
-		// Bottom
-		if(!belowIsDoor) {
-			setBrightness(tessellator, worldSource, x, y - 1, z, sideBottom);
-			renderBlocks.renderBottomFace(tessellator, bounds, x, y, z, getBlockTexture(worldSource, x, y, z, Side.BOTTOM));
-		}
-		
-		// Top
-		if(!aboveIsDoor) {
-			setBrightness(tessellator, worldSource, x, y + 1, z, sideTop);
-			renderBlocks.renderTopFace(tessellator, bounds, x, y, z, getBlockTexture(worldSource, x, y, z, Side.TOP));
-		}
-		
-		// North
-		if(bounds.minZ > FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, worldSource, x, y, z, sideNorthSouth);
-		}else {
-			setBrightness(tessellator, worldSource, x, y, z - 1, sideNorthSouth);
-		}
-		renderBlocks.flipTexture = shouldFlipTexture(Side.NORTH, meta);
-		IconCoordinate texture = getBlockTexture(worldSource, x, y, z, Side.NORTH);
-		renderBlocks.renderNorthFace(tessellator, bounds, x, y, z, texture);
-		renderBlocks.flipTexture = false;
-		
-		// South
-		if(bounds.maxZ < 1.0f - FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, worldSource, x, y, z, sideNorthSouth);
-		}else {
-			setBrightness(tessellator, worldSource, x, y, z + 1, sideNorthSouth);
-		}
-		renderBlocks.flipTexture = shouldFlipTexture(Side.SOUTH, meta);
-		texture = getBlockTexture(worldSource, x, y, z, Side.SOUTH);
-		renderBlocks.renderSouthFace(tessellator, bounds, x, y, z, texture);
-		renderBlocks.flipTexture = false;
-		
-		// West
-		if(bounds.minX > FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, worldSource, x, y, z, sideEastWest);
-		}else {
-			setBrightness(tessellator, worldSource, x - 1, y, z, sideEastWest);
-		}
-		renderBlocks.flipTexture = shouldFlipTexture(Side.WEST, meta);
-		texture = getBlockTexture(worldSource, x, y, z, Side.WEST);
-		renderBlocks.renderWestFace(tessellator, bounds, x, y, z, texture);
-		renderBlocks.flipTexture = false;
-		
-		// East
-		if(bounds.maxX < 1.0f - FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, worldSource, x, y, z, sideEastWest);
-		}else {
-			setBrightness(tessellator, worldSource, x + 1, y, z, sideEastWest);
-		}
-		renderBlocks.flipTexture = shouldFlipTexture(Side.EAST, meta);
-		texture = getBlockTexture(worldSource, x, y, z, Side.EAST);
-		renderBlocks.renderEastFace(tessellator, bounds, x, y, z, texture);
-		renderBlocks.flipTexture = false;
-		return true;
-	}
-    
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+        }
+        tessellator.setColorOpaque_F(1.0f, 1.0f, 1.0f);
+
+        AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
+        TilePos queryPos = new TilePos();
+
+        float sideBottom = 1.0f;
+        float sideTop = 1.0f;
+        float sideNorthSouth = 1.0f;
+        float sideEastWest = 1.0f;
+        if (ENABLE_DIRECTIONAL_LIGHTING) {
+            sideBottom = 0.5f;
+            sideTop = 1.0f;
+            sideNorthSouth = 0.8f;
+            sideEastWest = 0.6f;
+        }
+
+        boolean aboveIsDoor = Block.hasLogicClass(worldSource.getBlock(tilePos.up(queryPos)), BlockLogicDoor.class);
+        boolean belowIsDoor = Block.hasLogicClass(worldSource.getBlock(tilePos.down(queryPos)), BlockLogicDoor.class);
+
+        int meta = worldSource.getBlockData(tilePos);
+
+        // Bottom
+        if (!belowIsDoor) {
+            setBrightness(tessellator, worldSource, tilePos.down(queryPos), sideBottom);
+            renderBlocks.renderBottomFace(tessellator, bounds, tilePos, getBlockTexture(worldSource, tilePos, Side.BOTTOM));
+        }
+
+        // Top
+        if (!aboveIsDoor) {
+            setBrightness(tessellator, worldSource, tilePos.up(queryPos), sideTop);
+            renderBlocks.renderTopFace(tessellator, bounds, tilePos, getBlockTexture(worldSource, tilePos, Side.TOP));
+        }
+
+        // North
+        if (bounds.minZ() > FULL_CUBE_THRESHOLD) {
+            setBrightness(tessellator, worldSource, tilePos, sideNorthSouth);
+        } else {
+            setBrightness(tessellator, worldSource, tilePos.north(queryPos), sideNorthSouth);
+        }
+        renderBlocks.flipTexture = shouldFlipTexture(Side.NORTH, meta);
+        IconCoordinate texture = getBlockTexture(worldSource, tilePos, Side.NORTH);
+        renderBlocks.renderNorthFace(tessellator, bounds, tilePos, texture);
+        renderBlocks.flipTexture = false;
+
+        // South
+        if (bounds.maxZ() < 1.0f - FULL_CUBE_THRESHOLD) {
+            setBrightness(tessellator, worldSource, tilePos, sideNorthSouth);
+        } else {
+            setBrightness(tessellator, worldSource, tilePos.south(queryPos), sideNorthSouth);
+        }
+        renderBlocks.flipTexture = shouldFlipTexture(Side.SOUTH, meta);
+        texture = getBlockTexture(worldSource, tilePos, Side.SOUTH);
+        renderBlocks.renderSouthFace(tessellator, bounds, tilePos, texture);
+        renderBlocks.flipTexture = false;
+
+        // West
+        if (bounds.minX() > FULL_CUBE_THRESHOLD) {
+            setBrightness(tessellator, worldSource, tilePos, sideEastWest);
+        } else {
+            setBrightness(tessellator, worldSource, tilePos.west(queryPos), sideEastWest);
+        }
+        renderBlocks.flipTexture = shouldFlipTexture(Side.WEST, meta);
+        texture = getBlockTexture(worldSource, tilePos, Side.WEST);
+        renderBlocks.renderWestFace(tessellator, bounds, tilePos, texture);
+        renderBlocks.flipTexture = false;
+
+        // East
+        if (bounds.maxX() < 1.0f - FULL_CUBE_THRESHOLD) {
+            setBrightness(tessellator, worldSource, tilePos, sideEastWest);
+        } else {
+            setBrightness(tessellator, worldSource, tilePos.east(queryPos), sideEastWest);
+        }
+        renderBlocks.flipTexture = shouldFlipTexture(Side.EAST, meta);
+        texture = getBlockTexture(worldSource, tilePos, Side.EAST);
+        renderBlocks.renderEastFace(tessellator, bounds, tilePos, texture);
+        renderBlocks.flipTexture = false;
+        return true;
+    }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
 
-    protected boolean shouldFlipTexture(Side side, int meta){
-        if(side == Side.TOP || side == Side.BOTTOM) return false;
-        int state = block.getLogic().getRotation(meta);
+    protected boolean shouldFlipTexture(@NotNull Side side, int meta) {
+        if (side == Side.TOP || side == Side.BOTTOM) return false;
+        int state = this.block.getLogic().getRotation(meta);
         int l = state / 2 + (side.getId() & 1 ^ state);
-        if((state == 0 || state == 2) ^ (side.getId() <= 3))
-        {
+        if ((state == 0 || state == 2) ^ (side.getId() <= 3)) {
             return false;
         }
         l += (meta & 4) / 4;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
index cecdafc59..659a04668 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
@@ -3,13 +3,14 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelDoorGlass<T extends BlockLogicDoor> extends BlockModelDoor<T> {
     public BlockModelDoorGlass(Block<T> block) {
         super(block);
     }
     @Override
-    protected boolean shouldFlipTexture(Side side, int meta){
+    protected boolean shouldFlipTexture(@NotNull Side side, int meta){
         return false;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
index 5e9e61c16..3bf6d7473 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelDoorPainted<T extends BlockLogicDoor> extends BlockModelDoor<T> {
@@ -27,12 +28,12 @@ public class BlockModelDoorPainted<T extends BlockLogicDoor> extends BlockModelD
         this.isTop = isTop;
     }
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data)
     {
         int color = (data >> 4) & DyeColor.MASK_COLOR;
         if (side.getAxis() == Axis.Y){
             return frameTopTextures[color];
-        } else if (isTop){
+        } else if (this.isTop){
             return doorTopTextures[color];
         }
         return doorBottomTextures[color];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
index b1d381d22..36d0d7d2b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -15,7 +16,7 @@ public class BlockModelEmpty<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, final int x, final int y, final int z) {
+    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return false;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
index d3e746ab6..3b9a2ad41 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicFarmland;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFarmland<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -20,24 +21,24 @@ public class BlockModelFarmland<T extends BlockLogic> extends BlockModelStandard
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, final int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, final int data)
     {
         boolean isWet = BlockLogicFarmland.isWet(data);
         boolean isFertilized = BlockLogicFarmland.isFertilized(data);
 
         if (side == Side.TOP) {
             if (isWet && isFertilized) {
-                return topWetFertilized;
+                return this.topWetFertilized;
             } else if (isWet) {
-                return topWet;
+                return this.topWet;
             } else if (isFertilized) {
-                return topDryFertilized;
+                return this.topDryFertilized;
             } else {
-                return topDry;
+                return this.topDry;
             }
         } else {
             if (isWet) {
-                return mud;
+                return this.mud;
             }
             return super.getBlockTextureFromSideAndMetadata(side, data);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 9c84b7a54..8ffd6326b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -5,16 +5,19 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
-public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStandard<T> {
+public class BlockModelFence<T extends BlockLogicFence> extends BlockModelStandard<T> {
     protected static final DisplayPos FENCE_GUI = new DisplayPos(0, 0, 0, 30, 225 - 90, 0, 0.625f, 0.625f, 0.625f);
     protected static final DisplayPos FENCE_HEAD = new DisplayPos(0, 0, 0, 0, 90, 0, 1f, 1f, 1f);
+
     public BlockModelFence(Block<T> block) {
         super(block);
 
@@ -23,28 +26,25 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final float f = 0.375F;
         final float f1 = 0.625F;
-        AABB bounds = AABB.fromPool(f, 0.0F, f, f1, 1.0F, f1);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        AABBd bounds = new AABBd(f, 0.0F, f, f1, 1.0F, f1);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         boolean connectedWestEast = false;
         boolean connectedNorthSouth = false;
-        BlockLogicFence fence = block.getLogic();
-        if(fence.canConnectTo(worldSource, x, y, z, Side.WEST) || fence.canConnectTo(worldSource, x, y, z, Side.EAST))
-        {
+        BlockLogicFence fence = this.block.getLogic();
+        if (fence.canConnectTo(worldSource, tilePos, Side.WEST) || fence.canConnectTo(worldSource, tilePos, Side.EAST)) {
             connectedWestEast = true;
         }
-        if(fence.canConnectTo(worldSource, x, y, z, Side.NORTH) || fence.canConnectTo(worldSource, x, y, z, Side.SOUTH))
-        {
+        if (fence.canConnectTo(worldSource, tilePos, Side.NORTH) || fence.canConnectTo(worldSource, tilePos, Side.SOUTH)) {
             connectedNorthSouth = true;
         }
-        boolean flag3 = fence.canConnectTo(worldSource, x, y, z, Side.WEST);
-        boolean flag4 = fence.canConnectTo(worldSource, x, y, z, Side.EAST);
-        boolean flag5 = fence.canConnectTo(worldSource, x, y, z, Side.NORTH);
-        boolean flag6 = fence.canConnectTo(worldSource, x, y, z, Side.SOUTH);
-        if(!connectedWestEast && !connectedNorthSouth)
-        {
+        boolean flag3 = fence.canConnectTo(worldSource, tilePos, Side.WEST);
+        boolean flag4 = fence.canConnectTo(worldSource, tilePos, Side.EAST);
+        boolean flag5 = fence.canConnectTo(worldSource, tilePos, Side.NORTH);
+        boolean flag6 = fence.canConnectTo(worldSource, tilePos, Side.SOUTH);
+        if (!connectedWestEast && !connectedNorthSouth) {
             connectedWestEast = true;
         }
         final float f8 = 0.4375F;
@@ -55,65 +55,50 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
         final float f5 = flag4 ? 1.0F : f9;
         final float f6 = flag5 ? 0.0F : f8;
         final float f7 = flag6 ? 1.0F : f9;
-        if(connectedWestEast)
-        {
-            bounds.set(f4, f2, f8, f5, f3, f9);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (connectedWestEast) {
+            bounds.setMin(f4, f2, f8).setMax(f5, f3, f9);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if(connectedNorthSouth)
-        {
-            bounds.set(f8, f2, f6, f9, f3, f7);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (connectedNorthSouth) {
+            bounds.setMin(f8, f2, f6).setMax(f9, f3, f7);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
         final float f10 = 0.375F;
         final float f11 = 0.5625F;
-        if(connectedWestEast)
-        {
-            bounds.set(f4, f10, f8, f5, f11, f9);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (connectedWestEast) {
+            bounds.setMin(f4, f10, f8).setMax(f5, f11, f9);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if(connectedNorthSouth)
-        {
-            bounds.set(f8, f10, f6, f9, f11, f7);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        if (connectedNorthSouth) {
+            bounds.setMin(f8, f10, f6).setMax(f9, f11, f7);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
         return true;
     }
 
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if(renderBlocks.useInventoryTint)
-        {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-            float r = (float)(color >> 16 & 0xff) / 255F;
-            float g = (float)(color >> 8 & 0xff) / 255F;
-            float b = (float)(color & 0xff) / 255F;
+        if (renderBlocks.useInventoryTint) {
+            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+            float r = (float) (color >> 16 & 0xff) / 255F;
+            float g = (float) (color >> 8 & 0xff) / 255F;
+            float b = (float) (color & 0xff) / 255F;
             GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
         }
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-        for(int cube = 0; cube < 4; cube++)
-        {
+        for (int cube = 0; cube < 4; cube++) {
 
-            AABB bounds;
+            AABBdc bounds;
             final float radius = 0.125F;
             final float f5 = 0.0625F;
-            switch (cube) {
+            bounds = switch (cube) {
                 // Vertical Beams
-                case 0:
-                    bounds = AABB.fromPool(0.5F - radius, 0.0F, 0.0F, 0.5F + radius, 1.0F, radius * 2.0F);
-                    break;
-                case 1:
-                    bounds = AABB.fromPool(0.5F - radius, 0.0F, 1.0F - radius * 2.0F, 0.5F + radius, 1.0F, 1.0F);
-                    break;
+                case 0 -> new AABBd(0.5F - radius, 0.0F, 0.0F, 0.5F + radius, 1.0F, radius * 2.0F);
+                case 1 -> new AABBd(0.5F - radius, 0.0F, 1.0F - radius * 2.0F, 0.5F + radius, 1.0F, 1.0F);
                 // Horizontal Beams
-                case 2:
-                    bounds = AABB.fromPool(0.5F - f5, 1.0F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 1.0F - f5, 1.0F + f5 * 2.0F);
-                    break;
-                case 3:
-                default:
-                    bounds = AABB.fromPool(0.5F - f5, 0.5F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 0.5F - f5, 1.0F + f5 * 2.0F);
-                    break;
-            }
+                case 2 -> new AABBd(0.5F - f5, 1.0F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 1.0F - f5, 1.0F + f5 * 2.0F);
+                default -> new AABBd(0.5F - f5, 0.5F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 0.5F - f5, 1.0F + f5 * 2.0F);
+            };
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, -1F, 0.0F);
